 @***
(originally divyield.prg)
Note: In setting OMfill refer to strings below, to getsub.ex, to getsub proc
in c.g and jab7.prg:
string tstat_str =  {"lr","M","_tcovb","_ssigb","_tcovfs","_fssig","_tcov0",
                     "_ssig0","_tcov1","_ssig1", "_etas"};
string loc_str =  {"_lagi", "_trendi", "ktypei", "optioni", "datai"};
***@

/****this version updated on Oct.1, 2005*******/
new;

declare h1;
_m=1;
cls;
h1="two sided";
library pgraph;
output file = longhornewtbret.out reset;
/*newdir = "d:/cowork2/longhor/"; when use Alex's computer, take off this part from the following directary*/
#include simuvolk/proc/stock.g;
#include simuvolk/stock/campbell/LHREGHH.G;
#include simuvolk/stock/campbell/LHREGNW.G; 
#include simuvolk/stock/campbell/hachh.g;
#include simuvolk/stock/campbell/hacnw.g;
#include simuvolk/proc/jab.prc;
#include simuvolk/proc/cowork2.prc;
#include /share2/proc/mic1.g;
/*#include proc/ptv3.src;*/
#include simuvolk/proc/boundtest.prc;
string dirwei = "/econ/share2/wei/";  @CES@
string dirwei2 = "/econ/share2/";     @CES@/*not useful*/

@**SETTINGS**@


override = "no"; @"yes" to override previously stored results.
                  "no" to only calculate new results
		  after corrections or changes put to yes
		  if program terminates part way through put to no to avoid duplication@


string yvar   = {"lrr"}; @string vector. y -variable. choices are:
                    lrr: log-real return (Campbell)
		    ler: log-excess (over treasury bill) return (Campbell) @


string xvar   =  {"tbret"}; @string vector. x - variable. Choices are:
                    ldp:   log dividend price ratio (12 mo. div/current price) (Campbell)
		    Dtbr:  Detrended tbill rate (Campbell)
		    tbret: tbill rate (Campbell)
		    sp:    Bond spread (Campbell) @ 
string spec   = {"longhor"}; @string vector. Regression specification. Choices are:
                    longhor:  long horizon returns -- don't use for sign tests
		    longlag:  simple return, long-lagged regressors: (one period return)
            longlagpredi: simple return, feedback variable is the predicted y@
hackern        = {"nw"}; @choices are "hh" for hansen-hodrick and "nw" for newey-west@
/*string sample  = {"test","test2"}; */

string sample  = {"27to03","27to94","27to51","52to94","52to03"}; 
                    @string Campbell data sample period. choices are 
		    "27to03","27to94","27to51","52to94","52to2003","test","test2"@


/*_k               = 1|3|12|24;   @horizon of return (in months)@    */
 _k             = 1|3|12|24|36|48;   @horizon of return (in months)@    
 
_print         = "no";  @ "yes" to send tables to printer,"no" not to print@
__view          = "no";  @ "yes" to view tables using xdvi, "no" not to@
@*******@
_graph =0; @0 no, 1 yes@
@*************@


@defunct settings: just leave as is (lines below)@
job            = 2;   
dataset = "campbell"; 
string stdir = "store";
string dname = "store";
optset = "";
string rownamereg = { "$\\hat{\\beta}$","$ R^2 $","$t_{\\beta}$" };
string headingsc  = "";
string headingsd  = "Forecast Horizon (k) ";
colname =  ""$+ftocv(_k',4,3);
colname = "$k = $ " $~ colname;
string ftsize ="100";
string align = "l";
/*string headings = "";*/
/*headrows = 0;*/







@**start main loops**@
hacki = 1;
do until hacki> rows(hackern);
  if hackern[hacki] $== "hh";
    string _hackern = "Hansen-Hodrick";
  elseif hackern[hacki] $== "nw";
    string _hackern = "Newey-West";
  else;
    "Error: divyield.prg. hackern must be  hh for Hodrick Hansen or  nw for Newewy-West";
    end;
  endif;
  yvari = 1;
  do until yvari > rows(yvar);
    xvari = 1;
    do until xvari>rows(xvar);
      /******/
      zz = xvar[xvari];
      if zz $=="ldp";
	string xtitle  = "log dividend price ratios";
	string xheadings = "$x_t = ln \\left((D_t+\\ldots + D_{t-12})/P_t \\right)$";
      elseif zz $=="Dtbr";
	string xheadings = "$x_{t} = i_t-\\sum_{j=0}^{11} i_{t-j}$";
	string xtitle  = "detrended one-month treasury bill rates";
      elseif zz $== "tbret";
	string xtitle  = "one-month treasury bill rates";
	string xheadings = "$x_{t} = i_t$";
      elseif zz $== "sp";
	string xtitle  = "bond yields";
	string xheadings = " ";
      elseif zz $=="ldpr1";
	string xtitle  = "simple log dividend price ratios";
	string xheadings = "$x_t = ln \\left(D_t/P_t \\right)$";	       
      elseif zz $=="ldpr2";
	string xtitle  = "log dividend price ratios";
	string xheadings = "$x_t = ln \\left((D_t+\\ldots + D_{t-12})/P_t \\right)$";	    
      elseif zz $=="tbr";	
	string xtitle  = "treasury bill rates";
	string xheadings = "$x_{t} = i_t$";
      elseif zz $=="lp";	
	string xtitle  = "log stock prices";
	string xheadings = "$x_t = ln \\left(/P_t \\right)$";	       
      else;
	"xvar not set correctly. Replace " zz;
	end;
      endif;
      /******/
      speci = 1;
      do until speci >rows(spec);
	zz = spec[speci];
	if zz $=="longhor";
	  string spectit = {"long horizon", ""};      
	  string specheadings = " $y_{t+k} = r_{t+1}+ \\ldots + r_{t+k}  $";
@new@     string specheadingsb = " ";	  
	  footnotereg = "Regressions are estimated by OLS with " $+ _hackern $+ 
	  " standard errors, setting the bandwidth equal to $k-1$.";
	elseif zz $== "longlag";
	  string spectit = {"one-period", "the sum of the past $k$ "};      
	  string specheadings = "$ y_{t+1} = r_{t+1} $";         @ log lag@
	  @new@     string specheadingsb = "$x_{t,k} = \\sum_{j=0}^{k-1} x_{t-j} $ ";	  
	  footnotereg = "Regressions are estimated by OLS";
	else;
	  "spec not set correctly. Replace " zz;
	  end;
	endif;
	headings = specheadings$| xheadings $| specheadingsb   $|headingsc$|headingsd; 
	headrows = seqa(-1,-1,rows(headings));
	headrowsreg = headrows;
	sampi = 1;
	do until sampi >rows(sample);
	  @**set sample string name***@
	  if dataset $=="old";
	    _samples = ""$+ftocv(sample[sampi,.],0,0); @all samples@
	    _sample="d" $+_samples[.,2] $+ _samples[.,1] $+ "to" $+ _samples[.,4] $+_samples[.,3];
	  elseif dataset $=="campbell";
	    _samples = sample; @all samples@
	    _sample  = sample[sampi]; 
	  endif;
	  @Automated Settings@
	  "date " date;
	  "time " time;
	  ttime = time;
	  ttime2 = ttime;
	  _k1   = ""$+ftocv(_k,0,0);
	  __k ="k"; 
	  i =1;
	  do until i>rows(_k);
	    __k = __k $+ _k1[i];
	    i = i+1;
	  endo;
	  __k;
	  stn0 = _samples;
	  stn1 =  stn0 $+ __k $+ hackern[hacki]$+spec[speci] $+ yvar[yvari] $+ xvar[xvari] $+ optset $+"opt"; 
/*	  stn1 =  _samples $+ __k $+ hackern[hacki]$+spec[speci] $+ yvar[yvari] $+ xvar[xvari]; */
	  stn = stdir $+ stn1; 
	  stnreg =  stn $+ "reg";
 	  _stn = stn[sampi];
	  _skip = "no";
	  if override $=="no";
	    exists = filesa(_stn$+".fmt");
	    if exists $=="";  @check if store file exists already@    
              "store results do NOT exist: performing calculations";
	    else;
              "store results exists: skipping calculations";
	      _skip = "yes";
	    endif;
	  endif;
	  @*********@


	  @**LOAD DATA**@
         @NOTE: Need to determine if the 99s in first row impact results@
	  if dataset $== "old" ;
	    mo1  = sample[sampi,1];
	    yr1  = sample[sampi,2];
	    moN  = sample[sampi,3];
	    yrN = sample[sampi,4];
	    {yr,mo,day,rd,rnd,tbr} =  loaddata(mo1,yr1,moN,yrN); @data I collected@
	  elseif dataset $=="campbell" ; 
/*        load indicesx[937,5]=d:/cowork2/longhor/stock/campbell/indicesx3up.dat;*/
/*	    load indicesx[829,5]=stock/campbell/indicesx3test.dat;  the old directary*/@test version of old data@  
/*	    load indicesx[829,5]=stock/campbell/indicesx3.dat; @old version@  */
/*	    load indicesx[937,5]=stock/campbell/indicesx3up.dat;  @updated old version@ */
	    load indicesx[937,5]=stock/campbell/indicesx4.dat;  @new version@  


	    @campbell stock index data@
 /*       load sbbi[937,6]=d:/cowork2/longhor/stock/campbell/sbbi3up.dat;*/
/*	    load sbbi[829,6]=stock/campbell/sbbi3test.dat; old directary on Alex's computer*/ @test version of old data@ 
/*	    load sbbi[829,6]=stock/campbell/sbbi3.dat; @old version@ */
/*	    load sbbi[937,6]=stock/campbell/sbbi3up.dat; @updated old version@ */
            load sbbi[937,6]=stock/campbell/sbbi4.dat; @new version@  


	    @campbell cpi, treasury bill data: 25.12 - 94.12 @
	    
	    @**form variables: from campbell**@
	    vwretd=indicesx[.,2]; @value weighted returns including dividends (me: rd)@
	    vwindx=indicesx[.,5]; @value weighted price index excluding dividends (me: rnd)@
	    gbtret=sbbi[.,2];  @what's the defn?@
	    gbiret=sbbi[.,3];  @what's the defn?@
	    gbcret=sbbi[.,4];  @what's the defn?@
	    tbret=sbbi[.,5];  @return (rate) on treasury bill@
	    cpiret=sbbi[.,6]; @return on CPI (inflation rate)@
	    clear indicesx;
	    clear sbbi;
	    
	    div=((vwretd[2:rows(vwretd)]+1).*vwindx[1:rows(vwretd)-1]) - vwindx[2:rows(vwretd)]; 
	    /*26.01 94.12*/
	    @D_t. This is the Dividend series@ 
	    dpr=zeros(rows(vwretd)-13,1); /* We start the Div.-Prc. ratio at 27.01: 816 obs. */
	    @Dividend price ratio (last year of dividend, current price@
	    i=13; 
	    do while i<= rows(dpr)+12;
/*	      dpr[i-12]=sumc(DIV[i-11:i,1])/vwindx[i,1];  @old version: found error@ */
	      dpr[i-12]=sumc(DIV[i-12:i-1,1])/vwindx[i,1];  @updated Dec 2, 2006@ 
	      @note that div extends back further than dpr so that dpr[i-12] has
	      same date as Div[i,1]@
	      i=i+1;
	    endo;
	    ldp=ln(dpr); @log dividend price ration (1 yr dividend/current price)@
   
	    tbind=zeros(rows(tbret),1);
	    tbind[1]=100;
	    i=2; do while i<=rows(tbret);
	      tbind[i]=tbind[i-1]*(1+tbret[i]);  @treasury bill index@
	      i=i+1;
	    endo;
	    
	    /* Deviations of the nominal short rate from its backward 1-year moving
	    average, 1927.01 - 1994.12 */
	    Dtbr=zeros(rows(tbret)-13,1); /* We start at 27.01: 816 obs. */
	    tbret2 = zeros(rows(tbret)-13,1); @new truncated tbret@
	    i=14; do while i<= rows(Dtbr)+12;
	      tmp=tbret[i-11:i];
	      Dtbr[i-12]=tbret[i]-meanc(tmp); @tbret detrended@
	      tbret2[i-12] = tbret[i];   @tbret not detrended@
	      @Stochastically detrendended treasury bill rate: subtract off last year's average@
	      i=i+1;
	    endo;
	    ybond1=(gbtret[1:613]-gbcret[1:613])*12;  /* need to annualize */
	    ybond2=(((gbiret[614:rows(gbiret)]+1)^6) - 1)*2; /* no need */
	    ybond=ybond1|ybond2; 
	    clear ybond1; 
	    clear ybond2;
	    ytb=tbret*12; /* need to annualize */
	    
	    /* log real returns */
	    lrr=ln(1+vwretd)-ln(1+cpiret); @log real return with dividend@
	    lrr=lrr[14:rows(lrr)]; /* 27.01 - 94.12 */ @???@
	    @truncate to correspond to dividends@
	    /* log excess returns */
	    ler=ln(1+vwretd)-ln(1+tbret);  @log excess return w/dividend over tbret@
	    ler=ler[14:rows(ler)];
	    /* spread */
	    sp=ybond[2:rows(ybond)]-ytb[1:rows(ytb)-1];
	    sp=sp[14:rows(sp)]; /* 27.01 - 94.11 --> we lose one observation */
	    tbret = tbret2; @truncate tbret so it matches stoc. de-trended rate in timing@
	    
/**----------------------------------------------------------
 save tbret;
-------------------------------------------------------**/
 
	    @*** Select Sample: Campbell data***@
        /* I am adding two samples here, one is the new full sample 27-03, hence have to adjust
        the original full sample; the other is the new late sample 52-03.*/
        if sample[sampi] $=="27to03";
          string headsamp = "1927 to 2003";
        elseif sample[sampi] $=="27to94";
	      lrr = lrr[1:816];
	      ler = ler[1:816];
	      ldp = ldp[1:816];
	      tbret = tbret[1:816];
	      dtbr = dtbr[1:816];
	      sp = sp[1:815];
          string headsamp = "1927 to 1994";
        elseif sample[sampi] $=="27to51";
	      lrr = lrr[1:300];
	      ler = ler[1:300];
	      ldp = ldp[1:300];
	      tbret = tbret[1:300];
	      dtbr = dtbr[1:300];
	      sp = sp[1:300];	
	      string headsamp = "1927 to 1951";
	    elseif sample[sampi] $=="52to94";
	      lrr=lrr[301:816];                        
	      ler=ler[301:816];                        
	      ldp=ldp[301:816];
	      tbret = tbret[301:816];
	      dtbr = dtbr[301:816];
	      sp = sp[301:815];
	      string headsamp = "1952 to 1994";
        elseif sample[sampi] $== "52to03";
          lrr=lrr[301:924];                        
	      ler=ler[301:924];                        
	      ldp=ldp[301:924];
	      tbret = tbret[301:924];
	      dtbr = dtbr[301:924];
	      sp = sp[301:923];
	      string headsamp = "1952 to 2003";
	    elseif sample[sampi] $== "test";
	      lrr = lrr[1:100];
	      ler = ler[1:100];
	      ldp = ldp[1:100];
	      tbret = tbret[1:100];
	      dtbr = dtbr[1:100];
	      sp = sp[1:100];
              numcuts = 5;
	      string headsamp = "test sample";
	    elseif sample[sampi] $== "test2";
	      lrr = lrr[100:210];
	      ler = ler[100:210];
	      ldp = ldp[100:210];
	      tbret = tbret[100:210];
	      dtbr = dtbr[100:210];
	      sp = sp[100:210];
	      string headsamp = "test sample 2";
	    endif;
	  else;
	    "dataset has bad name";
	  endif;  
	  
	  if dataset $== "old" ; 	
	    @**FORM VARIABLES: ME**@
	    ldpr0 = mkldpr(yr,mo,rd,rnd,_graph);
	    ldpr1 = ldpr0[.,1]; @raw nominal log dividend price ratio: d-p@
	    ldpr2 = ldpr0[.,2]; @smoothed log dividend price ration: l
	    ln((D_t+D_{t-1}+...+D_{t-11})/P_t)@
	    clear ldpr0;		   
	    lrd = ln(1+rd); @nominal log return: r_t = ln(1+R_t): 
	    see Campbell,Lo,MacKinlay, p254@
	    kpsldpr2 = mkkpslx(ldpr2,_k); @sum of k-period lag (log) div-price ratio@	
	    lp = mklp(mo~yr,rnd);
	    /*
	    kplrd = mkkplrd(yr~mo,rd,_k); @matrix of k period returns (nominal): see stock.g@
	    @original version above. using campbell data below@ */
	  elseif dataset $=="campbell" ;
	    /*        kplrr =  mkkplrr(lrr,_k);       
	    kpler =  mkkplrr(ler,_k); @k period log excess return@
	    @NEED to make kplrr - kperiod log real returns@ */
	    
	  endif;
	  @***Form X and Y Variables ***@
	  zz = yvar[yvari];
	  if zz $=="lrr";
	    yt = lrr;
	    string ytitle  = "real stock returns";
	  elseif zz $=="ler";
	    yt = ler;
	    string ytitle  = "excess stock returns";	
	  elseif zz $=="lrd";
	    yt = lrd;
	    string ytitle  = "nominal stock returns";	
	  else;
	    "yvar not set correctly. Replace " zz;
	    end;
	  endif;
	 /*****/
	  zz = xvar[xvari];
	  if zz $=="ldp";
	    xt = ldp;
	  elseif zz $=="Dtbr";
	    xt = Dtbr;
	  elseif zz $== "tbret";
	    xt = tbret;
	  elseif zz $== "sp";
	    xt = sp;
	    yt = yt[1:rows(sp)];
	  elseif zz $=="ldpr1";
	    xt = ldpr1;
	  elseif zz $=="ldpr2";
	    xt = ldpr2;
	  elseif zz $=="tbr";	
	    xt = tbr;
	  elseif zz $=="lp";	
	    xt = lp;
	  else;
	    "xvar not set correctly. Replace " zz;
	    end;
	  endif;
	  /******/
	  zz = spec[speci];
	  if zz $=="longhor";
	    _m  = _k-1;   @ vector of bandwidths for HAC estimator (rows(_m) = cols(y_k))@
	    y = mkyk(yt,_k);
	    x2 = miss(zeros(rows(xt),cols(y)),0);
	    r = 1;
	    do until r>cols(x2);
	      x2[.,r] = xt;  @new Campbell data@ 
	      r = r+1;
	    endo;
	    x = mkkrep(xt,rows(_k));
	    x = x2;
	    clear x2;
	  elseif zz $== "longlag";
	    _m  = zeros(rows(_k),1);@vector of bandwidths for HAC estimator (rows(_m)=cols(y_k))@
	    x = mkkpslx(xt,_k);
	    y = mkkrep(yt,rows(_k));
	  else;
	    "spec not set correctly. Replace " zz;
	    end;
	  endif;
	  if dataset $== "old";
	    headsamp = sample[sampi];
	  endif;
	  headings = headings $| headsamp;
/*	  headrows = headrows | (1+(sampi-1)*cols(varshow));  @sampi@ */
  	  headrowsreg = headrowsreg | (1+(sampi-1)*rows(rownamereg));  @sampi@
	  ttitle = "Covariance-based orthogonality tests on " $+ spectit[1] $+ " " 
	  $+ ytitle $+ " using " $+ spectit[2] $+ ""  $+ xtitle;
	  ttitlereg = "Regression  of " $+ spectit[1] $+ " " 
	  $+ ytitle $+ " on " $+ spectit[2] $+ ""  $+ xtitle;
	  @***********************@
	  
	  @**Print settings**@
	 /* ttitle;
	  headings;
	  "dataset " dataset;
	  "sample " _sample;
	  "spec " spec[speci];
	  "yvar " yvar[yvari];
	  "xvar " xvar[xvari];  
*/
	  
@**Regression***@
	  @Long-horizon regression of log real return on log div. price@

	  res2 = hacreg(x,y,_m,hackern[hacki]);



	  _stnreg = stnreg[sampi]; 
/*	  save ^_stnreg = res2;   @save reg. results to .fmt file@ */
	  format 5,4; @temp@
	 /* "res2: (b|R2|tb)' " res2'; @temp@  */
	  " ";
	  if _skip $=="no";


       /****** Simultaneity estimation and largest root*****/
        penalty="mic";
        maxp=6;
        load path=/share2/wei/ cvdf3_a;
        cvdf_a=cvdf3_a[1,.]|sortc(cvdf3_a[2:rows(cvdf3_a),.],1);
        clear cvdf3_a;
        
        ylead=yt[1:rows(yt)-1,.]; xlead=xt[2:rows(xt),.]; xlag=xt[1:rows(xt)-1,.];
        if penalty $=="mic";
          minp = 1;
          penalty2 = 0;
          @** penalty: 0 for mic and 1 for bic.**@
          pstar=s2ar(xt,penalty2,maxp,minp);
          elseif penalty $=="bic";
           @Using CES bic criteria@
          {pstar,junk}=urbic(xt,1,maxp);
         endif;


          {aat,junk}=adf(xt,1,pstar);
   @ compute ADF unit root test - the 1 refers to including a constant @
          {ci1}=unitci(aat[2,1],0.95,cvdf_a);
    @ compute confidence interval on c, size is a1 @
          {cim}=unitci(aat[2,1],0.0,cvdf_a);


    {bet4,r4,pred} = olsqr2(ylead,xlag);
     
     @---- Estimate Delta-----@
@ estimate delta nuisance parameter @  
   
r1=xlead-(1+cim[1,1]/rows(xt))*xlag;
r2=ylead-bet4*xlag;
/*r2 = r2[1:rows(r2)-1];  */


{dhat,omega}=deltahat(r1,r2,1,rows(r2),maxp);
dhat=dhat[1,2];
dhat1=dhat;

print "     delta      tADF  lCIalpha  uCIalpha     lags";
/*format /m1 /rdn 10,4;*/
print dhat1~aat[2]~(1+ci1[1]/rows(xt))~(1+ci1[2]/rows(xt))~pstar;    
/*
yt;
save yt;
"kill here";
*/
/*******
@*****graph the series and save the figures*****@
graphset;

xlabel("\202t");
ylabel("\202dividend/price Ratio");
_paxes=1;
_pmcolor=4;
xy(seqa(1,rows(yt),1),yt[.,1]);
*******/
/*
svname ="fmt/";
fnmnew=yvar$+"full";
save path = ^svname ^fnmnew=yt;
*/
         
         
	   @***Sign tests***@
          @some procedures contained in proc/jab.prc@
     /*   res = sign1(x,y);  */         
     /*     "100*Sg/n    (100*se/n)  p-value";
          res';   */
/*          "percent of correct predictions (100*Sg/n)"  res[1];
          "standard error ( 100*se/n) " res[2];
          "p-value (pr)"  res[3];  */


/*         
@*****Calculated the predicted y and do the sign test again***@
/* calculate the predicted y using the beta estimated from x, added by wei*/
trahor = 2; /*this determines the training horizon, choices are 0=no training session, 1=50 as
             the training sample size, 2 = 60 as the training sample size. */
          if trahor == 0;
             n1 = 0;
             /*yhat = res2[1,.].*x;*/
             elseif trahor == 1;
             n1 = 50;
             yhat = zeros(rows(x)-n1,cols(x));
             for kk (1, rows(yhat), 1);
                res2tem = hacreg(x[1:n1+kk-1,.], y[1:n1+kk-1,.], _m, hackern[hacki]); 
                yhat[kk,.]=res2tem[1,.].*x[n1+kk,.];
              endfor;
            elseif trahor == 2;
            n1 = 100;
             yhat = zeros(rows(x)-n1,cols(x));
             for kk (1, rows(yhat), 1);
                res2tem = hacreg(x[1:n1+kk-1,.], y[1:n1+kk-1,.], _m, hackern[hacki]); 
                yhat[kk,.]=res2tem[1,.].*x[n1+kk,.];
              endfor;
                       
endif;
          
          reshat = sign1(yhat,y[n1+1:rows(y),.]);

          _graph = 0; @0= don't graph, 1=graph 2-sided test@
          _print = 1; @0=don't print output?? 1=print output?@
          name = ""; 
/*
          _ngrid=10^3; @number of grid points in the confidence interval J() over which Sg(b) is evaluated@
          alpha = 0.05; @ size of the orthogonality test@
          alpha1 =0.01;  @used to determine J(alpha1), an (1-alpha1) confidence
                  region for the unknown median of y_t @  
          {Sg,QL,QU,QBL,QBU,Sg_bar2,Sg_bar3,Sg_bar2B,Sg_bar3B} 
           = signstat2(y,xdm,alpha,alpha1,_ngrid,name,_graph,_print);
 
*/
*/

@--------sign rank test--------@

/* ret2 = signrnk1(x,y); */


@------Volkanov's bounds test----@

retsup=volkbounds(xt,yt,_k,"sup","pval"); /* the choices for 4th argument={"indicator", "pval"} */

@-----Moriera test--------@
/*
retmorie=zeros(1,rows(_k));
hor=1;
do until hor>rows(_k);
xlag=mkkpslx(xt,_k[hor]);
xylag=packr(yt~xlag);

/*
{muhat,Kmathat,sigmahat,tstat1,tstatwhite,qvals05,pvals1,qvalswhite05,pvalswhite}=ptv(xylag[.,1],xylag[.,2],0,0.05,"long");
p3 = pval2(pvals1);

*/
{junk1,junk2,junk3,junk4,junk5,junk6,pvals1,junk7,junk8}=ptv(xylag[.,1],xylag[.,2],0,0.05,"long");
p3 = pval2(pvals1);
retmorie[1,hor]=p3[3,.];
hor=hor+1;
endo;
*/
@------store in one matrix of the tb and sign test p-value-----@
/* here we are trying to put the p-value of tb and sign test together 
for one sample and different tests. added by Wei
*/
      ttitle;
	  headings;
	  "dataset " dataset;
	  "sample " _sample;
	  "spec " spec[speci];
	  "yvar " yvar[yvari];
	  "xvar " xvar[xvari]; 
/*ptb = cdfnc(abs(res2[3,.]));*/

ptb=cdfnc(abs(res2[3,.]));
ptb=res2[3,.]./abs(res2[3,.]).*ptb;
/*rescomp = _k'|ptb|res[3,.]|reshat[3,.];*/
/*rescomp=_k'|ptb|res[3,.]|ret2|retsup|retmorie;*/


rescomp=_k'|ptb*2|retsup;/**/
/*rescomp=_k'|ptb*2|res[3,.]*2|ret2*2;*/

/*rescomp=_k'|ptb;*/
format /m1 /rdn 10,4;

print rescomp; /**/


/************************************************************************************/
       
    
	    @***Covariance based tests***@
	    if job <= 0;
/*	      {store,loc_str,tstat_str} = 
	      tcovt2(_lags,_trends[trendi],ktypes,options,bwcsts,bwgrs,x,y,method,true_lr,alpha,
	      W,p_approx,q_approx,_etacst,_etagr,aalb,aaub,Blb,Bub,sides,rho12b,numcuts,optset,mtdf); */
	      /* _stn = stn[sampi]; */
/*	      save ^_stn = store;   @save to .fmt file@ */
	      >rm "/windows/tmp/apsi/*"; 
            elseif job ==3; @CES tests@              
              if rows(_k) ==1;
              else;
                "Error (divyield, job =3, ces) currently works only for rows(_k)=1: to correct add ces program modelled after tcovt2";
                end;
              endif;
              if y[rows(y)]==miss(0,0);
                x = x[1:rows(x)-1];
                y = y[1:rows(y)-1]; 
              endif;
              

/*              {tadf,CIrho,medrho,dhat1,gamhat,tgamhat,r4,ci2,bpv,cis,spv,cish,schpv,rejs}  = 
              ces2(x,y,h0,a1,a2,a2s,maxp,penalty,dirwei,dirwei2,_print,ces3_0, ces3_10, 
              ces3_20, ces3_30, ces3_40, ces3_50, ces3_60, ces3_70, ces3_80, ces3_90, ces3_95, 
              spdb, asel, cesf, ces2_0, ces2_10, ces2_20, ces2_30, ces2_40, ces2_50, ces2_60, 
              ces2_70, ces2_80,ces2_90,tstat,pval); */
/*              " CI on largest root     ";; CIrho; */
/*              " Delta                  ";;dhat1; */
	    endif;       
	  endif;
	    sampi = sampi+1;
	  endo;
	  if job >= 0 and job <=1;
/*	    divtab(stdir,stn0,stn1,dname,ttitle,rowname,colname,footnote,ftsize,
	    align,headings,headrows,OMfill,_print,__view); */
          endif;
          if job >=0 and job <=2;
/*            rowname =" "; 
	    regtab(stdir,stn0,stn1,dname,ttitlereg,rowname,colname,footnotereg,ftsize,
	    align,headings,headrowsreg,_print,__view); */
	  endif;
	speci = speci+1;
      endo;
      xvari = xvari +1;
    endo;
    yvari = yvari + 1;
  endo;
  hacki = hacki+1;
endo;


end;  

@***Procedures****@

@*******divtab********
Produces tables specifically for covariance based tests
****************************************************@    
proc(0)= divtab(stdir,stn0,stn1,dname,ttitle,rowname,colname,footnote,ftsize,align,headings,headrows,OMfill,_print,__view);
local store,fill,label,fillrow123,fillrow4,exists,stn,sampi,label2;
local fill2,rowname2,headcustom,_fname; @new@
sampi =1;
do until sampi>rows(stn1);
  stn = stdir $+ stn1[sampi];	 
 
"stdir " stdir;
"stn0 " stn0;
"stn1 " stn1;


  exists = filesa(stn$+".fmt");
  if exists $== "";
    "divtab: Error " stn$+".fmt does not exist. Have results been run yet?";
    end;
  endif;
/*  load store = ^stn; */
/*  fill = getsub(store,OMfill)'; */
  label = stn0[sampi];
  if sampi == 1;
    fill2 = fill;
    rowname2 = rowname;
    label2 = stn1[sampi];
  else;
    fill2 = fill2 | fill; @new@
    rowname2 = rowname2 $| rowname;
    label2 = label $+ label2; 
  endif;
  sampi = sampi+1;
endo;
fill = ""$+ftocv(fill2,5,4); @new@


"Table output saved to ";
dname$+label2$+".tex";
headcustom = zeros(rows(headrows),1);
_fname = label2;
/*lattab3(label2,dname,ttitle,rowname2,colname,footnote,ftsize,fill,align,headings,headrows,headcustom,_fname); */
if __view $=="yes" or _print$=="yes";
/*  latex(_fname,dname,_print,__view); */
endif;
endp;



@*******regtab********
Produces tables specifically for regression tests
****************************************************@    
proc(0)= regtab(stdir,stn0,stn1,dname,ttitlereg,rowname,colname,footnotereg,ftsize,align,headings,headrowsreg,_print,__view);
local sampi, stn, exists, _stnreg, fill, label, rownamereg2, fill2,label2, texfile;
sampi =1;
do until sampi>rows(stn1);
  stn = stdir $+ stn1[sampi];	 
  exists = filesa(stn$+"reg.fmt");
  if exists $== "";
    "divtab: Error " stn$+".fmt does not exist. Have results been run yet?";
    end;
  endif;
  _stnreg = stnreg[sampi];
  load fill =   ^_stnreg;
  if sampi == 1;
    fill2 = fill;
    rownamereg2 = rownamereg;
    label2 = stn1[sampi]$+"reg";
  else;
    fill2 = fill2 | fill; @new@
    rownamereg2 = rownamereg2 $| rownamereg;
    label2 = stn0[sampi]$+label2;
  endif;
  sampi = sampi+1;
endo;

if iscplx(fill2)*hasimag(fill2);
  fill = fill2;
  fill2 = real(fill2);
  ttitlereg = ttitlereg $+ "WARNING: CONTAINS COMPLEX RESULTS. hh COVARIANCE Matrix not singular
  try nw";
  "WARNING: CONTAINS COMPLEX RESULTS. hh COVARIANCE Matrix not singular";
endif;
fill = ""$+ftocv(fill2,3,3); @new@
"fill " fill;
texfile = dname$+label2;
"Table output saved to ";
texfile$+".tex";
/*lattab(label2,dname,ttitlereg,rownamereg2,colname,footnotereg,ftsize,fill,align,headings,headrowsreg);*/
if __view $=="yes" or _print$=="yes";
/*  latex(label2,dname,_print,__view); */
endif;
endp;





/****** hacreg *******
hackkern:  string of kernel in HAC estimation. Choices are:
            "nw" for Newey-West or "hh" for Hansen-Hodrick 
_m      : vector of bandwidths for HAC estimator (rows(_m) = cols(y_k<));
          Campbell sets _m to _k-1 where k is the vector of horizons
y_k     : matrix of k period returns. Each col. corresponds
          to a k value in _k. entry i,j is given by
	  lrd_{t+1}+...+lrd_{t+_k_{j}}
	  Note: y_k will have some missing values towards the top 
x       : matrix of regressor (one col. of x for each col. of y_k (no constant included))
output:   
res     : 3 by rows(_m) matrix of regression output. Each column is output for 1 regression
          including b|R2|tb, where tb is calculated using hac covariance. setting _m=0
	  gives standard (non-hac) t-statistic.
********/
proc hacreg(_x,y_k,_m,hackern);
local xx,yy,iT,b,S,tb,R2,u,m,datai,_xy,res;  
if rows(_m) == cols(y_k) and cols(y_k) == cols(x);
else;
   "lrheg: Error: rows(_m) NOT= cols(y_k) or cols(y_k) NOT= cols(x)";
  end;
endif;
res=zeros(3,rows(_m)); @save results@
datai = 1;
do until datai>rows(_m);
   
  _xy = packr(_x[.,datai]~y_k[.,datai]);  
  @Remove missing values. Note: series are column by column.@
  
  xx = _xy[.,1]; 
   
  yy = _xy[.,2];
  yy = yy - meanc(yy); @demean@
  xx = xx - meanc(xx); @demean@
  m = _m[datai];
  iT= rows(yy);
  b=inv(xx'xx)*xx'yy;
  u=yy-xx*b;
  if hackern $== "nw";
    S=hacnw(xx,u,m);
  elseif hackern $== "hh";
    S=hachh(xx,u,m);
  endif;
    tb=b./sqrt(diag(iT*inv(xx'xx)*S*inv(xx'xx)));
    R2 = (stdc(xx*b)/stdc(yy))^2; 
/*
" xxb ";; iscplx(xx*b);; imag(xx*b);
" xx ";; iscplx(xx);; imag(xx);
" b ";; iscplx(b);; imag(b);
wait;
*/

    if _m[datai] == 0; @Remove to replicate exactly for k=1@
      tb=b./sqrt(diag(inv(xx'xx)*1/(iT-2)*u'u ));
    endif; 
  res[.,datai]=b|R2|tb;
  datai = datai+1;
endo;
retp(res);
endp;
@***********@




/****** sign1 *******
sign1:  simple sign tests
y_k     : matrix of k period returns. Each col. corresponds
          to a k value in _k. entry i,j is given by
	  lrd_{t+1}+...+lrd_{t+_k_{j}}
	  Note: y_k will have some missing values towards the top 
x       : matrix of regressor (one col. of x for each col. of y_k (no constant included))
output:   
res     : 3 by rows(_m) matrix of regression output. Each column is output for 1 regression
          including  100*Sg/n| 100*se/n|p-val, where  100*Sg/n is percent of correctly signed 
          predictions, 100*se/n is the standard, p-val is the two sided p-value
********/
proc sign1(_x,y_k);
local xx,yy,iT,b,S,tb,R2,u,m,datai,_xy,res;  
local xdm, ydm,Sg,n,se,pr;
if rows(_m) == cols(y_k) and cols(y_k) == cols(x);
else;
   "sign1: Error: rows(_m) NOT= cols(y_k) or cols(y_k) NOT= cols(x)";
  end;
endif;
res=zeros(3,rows(_m)); @save res=results@
datai = 1;
do until datai>rows(_m);
  _xy = packr(_x[.,datai]~y_k[.,datai]);  
  @Remove missing values. Note: series are column by column.@
  xx = _xy[.,1];   
  yy = _xy[.,2];
  m = _m[datai];
  iT= rows(yy);
  xdm = med2(xx); @removes the median of x using only past x@
  ydm = yy-median(yy); /*suggestted by CD1997*/
  /*ydm = med2(yy); original from Alex's program*/
  {Sg,n,se,pr} = signstat(ydm,xdm,0);
  res[.,datai]= 100*Sg/n| 100*se/n|pr;
  datai = datai+1;
endo;
retp(res);
endp;
@***********@




/***************************************************************************
**		          	   signstat.g
**             	        	   ---------
****************************************************************************
**               Computes the Campbell-Dufour Sign Statistic
**         ----------------------------------------------------------
**  Under the null hypothesis that y_t  indep of y_t-1,y_t-2...., x_t-1,x_t-2,....
**  and the additional assumption that y_t is median zero, Sg is has a binomial(n,0.5) 
**  distribution. y = y_1,...y_n glag1 = g_0,...,g_n-1, g_t = g(x_t,x_t-1,...).  It may make sense 
**  demean or demedian y before running.  
**  {Sg,n,se,pr} = signstat(y,glag1,b)
**		
**  Sg is the sign statistic, which is binomial(n,0.5) under the null
**  n = rows(y)
**  se = standard deviation(Sg)
**  pr  =prob(X<Sg)  when X is binomial(n,0.5) 
**  (ie this provides a one sided test for a negative relationship between y and x)	
**        
**	
**   note:  100*Sg/n, 100*se/n - gives Sg (and se) is percent terms 
    (i.e. percent of positive y_t, g_t-1 pairs)
**	
**  note:  This calls cdfbi.g, which calls combin.g                      
**        
**   Reference: Cambell and Dufour, RESTAT 95 pp1-16,  Cambell & Dufour. IER, 97: 37(1)
***************************************************************************/
proc(4) = signstat(y,glag1,b);
local Sg,n,pr,v,se;
v = (y-b).*glag1 .> zeros(rows(y),1); 
   @indicator vector: 1 if (y_t-b) g_t-1 >0,  0 otherwise@
Sg = sumc(v); @number of y_t g_t-1 > 0 @
n = rows(y);

se = sqrt(n*.5*(1-.5)); @standard error of Sg under H_0@
/*
if Sg <= n*.5;
pr = cdfbi(Sg,n,0.5);
elseif Sg > n*.5;
pr = 1-cdfbi(Sg,n,0.5);
endif;
*/
/*pr = cdfbi(Sg,n,0.5); original from Alex*/
/****** use standard normal to approximate binomial******/


if Sg <= n*.5;
pr = cdfn((Sg-n*.5)/se);
pr=-pr;  /*** gives the sign the test***/
elseif Sg > n*.5;
pr = (1-cdfn((Sg-n*.5)/se));
endif;

/*
if h1$=="two sided";
else;
pr=cdfn((Sg-n*.5)/se);
endif;
*/
/*******************************************************/
retp(Sg,n,se,pr);
endp;
/************************************************************************/







/***mkkrep: make k repitions ****
inputs: y:       N by 1 data series
numrep:  number of repitions needed
output: ykrep:   N by numrep Matrix. 
All columns are equal to y, which has been repeated numrep times
*****/		 
proc(1) = mkkrep(y,numrep);
local r,ykrep;
ykrep = y;
r = 2;
do until r>numrep;
  ykrep = ykrep~y;
  r =r+1;
endo;
retp(ykrep);
endp;
@********************@

proc signrnk1(_x,y_k);
local xx,yy,iT,b,S,tb,R2,u,m,datai,_xy,res;  
local xdm, ydm,Srg,n,se,pr;
if rows(_m) == cols(y_k) and cols(y_k) == cols(_x);
else;
   "sign1: Error: rows(_m) NOT= cols(y_k) or cols(y_k) NOT= cols(x)";
  end;
endif;
res=zeros(1,rows(_m)); @save res=results@
datai = 1;
do until datai>rows(_m);
  _xy = packr(_x[.,datai]~y_k[.,datai]);  
  @Remove missing values. Note: series are column by column.@
 /* _xy = _x~y_k[.,1];*/
  xx = _xy[.,1];   
  yy = _xy[.,2];
  m = _m[datai];
  iT= rows(yy);
  /*xdm = xx-median(xx);*/
  /*ydm = yy;*/
  ydm = yy-median(yy);
  xdm = med2(xx); @removes the median of x using only past x@
 /* ydm = med2(yy); original */
 {Srg} = signrank(ydm,xdm,0);
  
  /*res[.,datai]= 100*Sg/n| 100*se/n|pr;*/
  
  n = rows(xdm);
  local pv;

if h1$=="two sided";
  if Srg < n*(n+1)/4;
  pv = cdfn((Srg - n*(n+1)/4)/sqrt(n*(n+1)*(2*n+1)/24));
  pv=-pv;  /***to identify the sign of this test***/
  else;
  pv = 1-cdfn((Srg - n*(n+1)/4)/sqrt(n*(n+1)*(2*n+1)/24));
  endif;
else;
 pv = cdfn((Srg - n*(n+1)/4)/sqrt(n*(n+1)*(2*n+1)/24));
endif;
  res[.,datai] = pv;
  datai = datai+1;
endo;
retp(res);
endp;
@***********@

@***
mkyk: make k-period return (y) from one period return
inputs:
  _k: column vector or return horizons or length
  y: N by 1 column vector of returns
outputs:
  kpy: k-period returns
         An N by rows(_k) matrix
         kpy[t,j] = (y_{t+1})+...+y{t+_k[j]})
****@
proc(1) = mkyk(y,_k);
local yleads,y_k,kk,kpy;
@form k- period nominal log return@
yleads = miss(zeros(rows(y),maxc(_k)),0); @cols are y_{k+1},lrd_{k+2},...,y_{t+masc(_k)@
y_k =  miss(zeros(rows(y),rows(_k)),0); @matrix of k period returns. Each col. corresponds
                                           to a k value in _k. entry i,j is given by
					   y_{t+1}+...+y_{t+_k_{j}}@



kk =1;
do until kk>maxc(_k);
  yleads[1:rows(y)-kk+1,kk] = y[1+kk-1:rows(y)];  
  kk=kk+1;
endo;
kk =1;
do until kk>rows(_k);
  y_k[.,kk] = sumc(yleads[.,1:_k[kk]]');
  kk=kk+1;
endo;
kpy = y_k;

retp(kpy);
endp;
@**************@

